
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>The Varnish Developers Guide &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Poul-Hennings random outbursts" href="../phk/index.html" />
    <link rel="prev" title="Upgrading to Varnish 4.0" href="../whats-new/upgrading-4.0.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../phk/index.html" title="Poul-Hennings random outbursts"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="../whats-new/upgrading-4.0.html" title="Upgrading to Varnish 4.0"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Varnish Developers Guide</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="the-varnish-developers-guide">
<span id="dev-guide-index"></span><h1>The Varnish Developers Guide<a class="headerlink" href="#the-varnish-developers-guide" title="Permalink to this headline">¶</a></h1>
<p>This is the deliberately short and to the point list of things
Varnish Developers should know.</p>
<section id="behaviour">
<h2>Behaviour<a class="headerlink" href="#behaviour" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>Be sensible.</p></li>
<li><p>If in doubt, think.</p></li>
<li><p>If still in doubt, ask.</p></li>
<li><p>Admit your mistakes, it’s faster that way.</p></li>
<li><p>Thou SHALL not paint <a class="reference external" href="http://bikeshed.org/">bikesheds.</a></p></li>
<li><p>We will toss you out of the project rather than add another rule.</p></li>
</ul>
</section>
<section id="technical-stuff">
<h2>Technical stuff<a class="headerlink" href="#technical-stuff" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>Our coding style guideline is FreeBSD’s
<a class="reference external" href="https://www.freebsd.org/cgi/man.cgi?query=style&amp;sektion=9">style(9)</a></p></li>
<li><p>See autogen.des script for developer options to the toolchain.</p></li>
<li><p>We always -Werror, there are no harmless warnings, only source code
that does not express intent well enough.</p></li>
<li><p>We prefer the source code, rather than the comments explain what is
going on, that way tools like FlexeLint and Coverity also gets a chance.</p></li>
<li><p>Our reference platforms are Ubuntu and FreeBSD.</p></li>
<li><p>Asserts have negative cost, they save developer time next time around.</p></li>
<li><p>Our license is BSD 2-clause or looser, no GPL or LGPL.</p></li>
<li><p>It took 11 years for the first major security issue, and that was too soon.</p></li>
</ul>
</section>
<section id="bugs-issues-feature-requests-vips">
<h2>Bugs, issues, feature requests &amp; VIPs<a class="headerlink" href="#bugs-issues-feature-requests-vips" title="Permalink to this headline">¶</a></h2>
<p>Bugs, issues and feature requests start out as github issues.</p>
<p>Monday at 13:00-14:00 (EU time) we “bug-wash” on IRC to
decide who and how issues are dealt with.</p>
<p>Issues we cannot do anything about are closed.</p>
<p>If feature-requests make sense, they get moved to a wiki/VIP page until
somebody implements them.</p>
<p>Varnishtest cases for bugs is the norm, not the exception.</p>
</section>
<section id="architectural-stuff">
<h2>Architectural stuff<a class="headerlink" href="#architectural-stuff" title="Permalink to this headline">¶</a></h2>
<p>These rules are imported from the X11 project:</p>
<ul class="simple">
<li><p>It is as important to decide what a system is not as to decide what it is.</p></li>
<li><p>Do not serve all the world’s needs; rather, make the system extensible so
that additional needs can be met in an upwardly compatible fashion.</p></li>
<li><p>The only thing worse than generalizing from one example is generalizing
from no examples at all.</p></li>
<li><p>If a problem is not completely understood, it is probably best to provide
no solution at all.</p></li>
<li><p>If you can get 90 percent of the desired effect for 10 percent of the work,
use the simpler solution.</p></li>
<li><p>Isolate complexity as much as possible.</p></li>
<li><p>Provide mechanism, rather than policy.</p></li>
</ul>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">The Varnish Developers Guide</a><ul>
<li><a class="reference internal" href="#behaviour">Behaviour</a></li>
<li><a class="reference internal" href="#technical-stuff">Technical stuff</a></li>
<li><a class="reference internal" href="#bugs-issues-feature-requests-vips">Bugs, issues, feature requests &amp; VIPs</a></li>
<li><a class="reference internal" href="#architectural-stuff">Architectural stuff</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="../whats-new/upgrading-4.0.html"
                        title="previous chapter">Upgrading to Varnish 4.0</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="../phk/index.html"
                        title="next chapter">Poul-Hennings random outbursts</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/dev-guide/index.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../phk/index.html" title="Poul-Hennings random outbursts"
             >next</a> |</li>
        <li class="right" >
          <a href="../whats-new/upgrading-4.0.html" title="Upgrading to Varnish 4.0"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Varnish Developers Guide</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>